/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2006 by The Mico Team
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>
#include <mico/throw.h>

#ifndef __SESSION_SERVICE_H__
#define __SESSION_SERVICE_H__






namespace tecgraf
{
namespace openbus
{
namespace session_service
{
namespace v1_05
{

class SessionEventSink;
typedef SessionEventSink *SessionEventSink_ptr;
typedef SessionEventSink_ptr SessionEventSinkRef;
typedef ObjVar< SessionEventSink > SessionEventSink_var;
typedef ObjOut< SessionEventSink > SessionEventSink_out;

class ISession;
typedef ISession *ISession_ptr;
typedef ISession_ptr ISessionRef;
typedef ObjVar< ISession > ISession_var;
typedef ObjOut< ISession > ISession_out;

class ISessionService;
typedef ISessionService *ISessionService_ptr;
typedef ISessionService_ptr ISessionServiceRef;
typedef ObjVar< ISessionService > ISessionService_var;
typedef ObjOut< ISessionService > ISessionService_out;

}
}
}
}



#include <core.h>
#include <scs.h>



namespace tecgraf
{
namespace openbus
{
namespace session_service
{
namespace v1_05
{

typedef char* SessionIdentifier;
typedef CORBA::String_var SessionIdentifier_var;
typedef CORBA::String_out SessionIdentifier_out;

typedef char* MemberIdentifier;
typedef CORBA::String_var MemberIdentifier_var;
typedef CORBA::String_out MemberIdentifier_out;

struct SessionEvent;
typedef TVarVar< SessionEvent > SessionEvent_var;
typedef TVarOut< SessionEvent > SessionEvent_out;


struct SessionEvent {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef SessionEvent_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  SessionEvent();
  ~SessionEvent();
  SessionEvent( const SessionEvent& s );
  SessionEvent& operator=( const SessionEvent& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var type;
  CORBA::Any value;
};


/*
 * Base class and common definitions for interface SessionEventSink
 */

class SessionEventSink : 
  virtual public CORBA::Object
{
  public:
    virtual ~SessionEventSink();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef SessionEventSink_ptr _ptr_type;
    typedef SessionEventSink_var _var_type;
    #endif

    static SessionEventSink_ptr _narrow( CORBA::Object_ptr obj );
    static SessionEventSink_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static SessionEventSink_ptr _duplicate( SessionEventSink_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static SessionEventSink_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual void push( const char* sender, const ::tecgraf::openbus::session_service::v1_05::SessionEvent& ev ) = 0;
    virtual void disconnect( const char* sender ) = 0;

  protected:
    SessionEventSink() {};
  private:
    SessionEventSink( const SessionEventSink& );
    void operator=( const SessionEventSink& );
};

// Stub for interface SessionEventSink
class SessionEventSink_stub:
  virtual public SessionEventSink
{
  public:
    virtual ~SessionEventSink_stub();
    void push( const char* sender, const ::tecgraf::openbus::session_service::v1_05::SessionEvent& ev );
    void disconnect( const char* sender );

  private:
    void operator=( const SessionEventSink_stub& );
};

#ifndef MICO_CONF_NO_POA

class SessionEventSink_stub_clp :
  virtual public SessionEventSink_stub,
  virtual public PortableServer::StubBase
{
  public:
    SessionEventSink_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~SessionEventSink_stub_clp ();
    void push( const char* sender, const ::tecgraf::openbus::session_service::v1_05::SessionEvent& ev );
    void disconnect( const char* sender );

  protected:
    SessionEventSink_stub_clp ();
  private:
    void operator=( const SessionEventSink_stub_clp & );
};

#endif // MICO_CONF_NO_POA


/*
 * Base class and common definitions for interface ISession
 */

class ISession : 
  virtual public CORBA::Object
{
  public:
    virtual ~ISession();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ISession_ptr _ptr_type;
    typedef ISession_var _var_type;
    #endif

    static ISession_ptr _narrow( CORBA::Object_ptr obj );
    static ISession_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ISession_ptr _duplicate( ISession_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ISession_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual char* getIdentifier() = 0;
    virtual char* addMember( ::scs::core::IComponent_ptr member ) = 0;
    virtual CORBA::Boolean removeMember( const char* identifier ) = 0;
    virtual ::scs::core::IComponentSeq* getMembers() = 0;

  protected:
    ISession() {};
  private:
    ISession( const ISession& );
    void operator=( const ISession& );
};

// Stub for interface ISession
class ISession_stub:
  virtual public ISession
{
  public:
    virtual ~ISession_stub();
    char* getIdentifier();
    char* addMember( ::scs::core::IComponent_ptr member );
    CORBA::Boolean removeMember( const char* identifier );
    ::scs::core::IComponentSeq* getMembers();

  private:
    void operator=( const ISession_stub& );
};

#ifndef MICO_CONF_NO_POA

class ISession_stub_clp :
  virtual public ISession_stub,
  virtual public PortableServer::StubBase
{
  public:
    ISession_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~ISession_stub_clp ();
    char* getIdentifier();
    char* addMember( ::scs::core::IComponent_ptr member );
    CORBA::Boolean removeMember( const char* identifier );
    ::scs::core::IComponentSeq* getMembers();

  protected:
    ISession_stub_clp ();
  private:
    void operator=( const ISession_stub_clp & );
};

#endif // MICO_CONF_NO_POA

typedef IfaceSequenceTmpl< ISession_var,ISession_ptr> SessionList;
typedef TSeqVar< IfaceSequenceTmpl< ISession_var,ISession_ptr> > SessionList_var;
typedef TSeqOut< IfaceSequenceTmpl< ISession_var,ISession_ptr> > SessionList_out;


/*
 * Base class and common definitions for interface ISessionService
 */

class ISessionService : 
  virtual public CORBA::Object
{
  public:
    virtual ~ISessionService();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ISessionService_ptr _ptr_type;
    typedef ISessionService_var _var_type;
    #endif

    static ISessionService_ptr _narrow( CORBA::Object_ptr obj );
    static ISessionService_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ISessionService_ptr _duplicate( ISessionService_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ISessionService_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual CORBA::Boolean createSession( ::scs::core::IComponent_ptr member, ::scs::core::IComponent_out session, CORBA::String_out identifier ) = 0;
    virtual ::scs::core::IComponent_ptr getSession() = 0;

  protected:
    ISessionService() {};
  private:
    ISessionService( const ISessionService& );
    void operator=( const ISessionService& );
};

// Stub for interface ISessionService
class ISessionService_stub:
  virtual public ISessionService
{
  public:
    virtual ~ISessionService_stub();
    CORBA::Boolean createSession( ::scs::core::IComponent_ptr member, ::scs::core::IComponent_out session, CORBA::String_out identifier );
    ::scs::core::IComponent_ptr getSession();

  private:
    void operator=( const ISessionService_stub& );
};

#ifndef MICO_CONF_NO_POA

class ISessionService_stub_clp :
  virtual public ISessionService_stub,
  virtual public PortableServer::StubBase
{
  public:
    ISessionService_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~ISessionService_stub_clp ();
    CORBA::Boolean createSession( ::scs::core::IComponent_ptr member, ::scs::core::IComponent_out session, CORBA::String_out identifier );
    ::scs::core::IComponent_ptr getSession();

  protected:
    ISessionService_stub_clp ();
  private:
    void operator=( const ISessionService_stub_clp & );
};

#endif // MICO_CONF_NO_POA

}
}
}
}


#ifndef MICO_CONF_NO_POA



namespace POA_tecgraf
{
namespace openbus
{
namespace session_service
{
namespace v1_05
{

class SessionEventSink : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~SessionEventSink ();
    tecgraf::openbus::session_service::v1_05::SessionEventSink_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static SessionEventSink * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual void push( const char* sender, const ::tecgraf::openbus::session_service::v1_05::SessionEvent& ev ) = 0;
    virtual void disconnect( const char* sender ) = 0;

  protected:
    SessionEventSink () {};

  private:
    SessionEventSink (const SessionEventSink &);
    void operator= (const SessionEventSink &);
};

class ISession : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~ISession ();
    tecgraf::openbus::session_service::v1_05::ISession_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static ISession * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual char* getIdentifier() = 0;
    virtual char* addMember( ::scs::core::IComponent_ptr member ) = 0;
    virtual CORBA::Boolean removeMember( const char* identifier ) = 0;
    virtual ::scs::core::IComponentSeq* getMembers() = 0;

  protected:
    ISession () {};

  private:
    ISession (const ISession &);
    void operator= (const ISession &);
};

class ISessionService : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~ISessionService ();
    tecgraf::openbus::session_service::v1_05::ISessionService_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static ISessionService * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual CORBA::Boolean createSession( ::scs::core::IComponent_ptr member, ::scs::core::IComponent_out session, CORBA::String_out identifier ) = 0;
    virtual ::scs::core::IComponent_ptr getSession() = 0;

  protected:
    ISessionService () {};

  private:
    ISessionService (const ISessionService &);
    void operator= (const ISessionService &);
};

}
}
}
}


#endif // MICO_CONF_NO_POA

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_session_service_v1_05_SessionEvent;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_session_service_v1_05_SessionEventSink;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_session_service_v1_05_ISession;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_session_service_v1_05_ISessionService;

extern CORBA::StaticTypeInfo *_marshaller__seq_tecgraf_openbus_session_service_v1_05_ISession;

#endif
